-- This schema migration moves away from using numeric patch table row ids
-- as foreign key references in related tables and switches to using the actual
-- text version id.

-- Alter report table add patch_version column.
ALTER TABLE report ALTER COLUMN patch_id DROP NOT NULL;
ALTER TABLE report ADD COLUMN patch_version TEXT;
ALTER TABLE report ADD CONSTRAINT report_patch_version_fkey
  FOREIGN KEY (patch_version) REFERENCES patch (version);
ALTER TABLE report DROP CONSTRAINT report_patch_id_fkey;

-- Alter livepatch_dist table to add patch_version column.
ALTER TABLE livepatch_dist ALTER COLUMN patch_id DROP NOT NULL;
ALTER TABLE livepatch_dist ADD COLUMN patch_version TEXT;
UPDATE livepatch_dist SET patch_version = patch.version
  FROM patch
  WHERE patch.id = livepatch_dist.patch_id;
ALTER TABLE livepatch_dist ADD CONSTRAINT livepatch_dist_patch_version_fkey
  FOREIGN KEY (patch_version) REFERENCES patch (version);
ALTER TABLE livepatch_dist DROP CONSTRAINT IF EXISTS livepatch_dist_patch_id_fkey;

CREATE UNIQUE INDEX livepatch_dist_kernel_version_patch_version_channel_key
  ON livepatch_dist (kernel_version, patch_version, channel);

-- Drop foreign key constraint from report_kernel_patch table.
ALTER TABLE report_kernel_patch DROP CONSTRAINT report_kernel_patch_patch_id_fkey;

-- Alter primary key of patch table.
ALTER TABLE patch DROP CONSTRAINT patch_pkey;
ALTER TABLE patch ADD PRIMARY KEY (version);
