-- sync_token table will allow setting a single tier per token,
-- same way as resource tokens will specify a single tier affordance.
ALTER TABLE sync_token ADD COLUMN tier int;
UPDATE sync_token SET tier = (SELECT id FROM channel WHERE name = COALESCE(tiers[0], 'updates'));
ALTER TABLE sync_token ADD CONSTRAINT sync_token_tier_fkey
  FOREIGN KEY (tier) REFERENCES channel(id) ON DELETE CASCADE;
ALTER TABLE sync_token DROP COLUMN tiers;
ALTER TABLE sync_token ALTER COLUMN tier SET NOT NULL;

-- Drop upstream tier record from sync report table.
ALTER TABLE sync_report DROP COLUMN upstream_tier;
