-- Drop retired report subtables.
DROP TABLE report_kernel_patch;
DROP TABLE report_kernel;

-- Add machine_uuid column to report table to directly store the machine uuid.
ALTER TABLE report DROP CONSTRAINT idx_report_uniq;
-- Attempt to add column. Postgresql 9.5 does not support 'ADD COLUMN IF NOT EXISTS'
DO $$
  BEGIN
    BEGIN
      ALTER TABLE report ADD COLUMN machine_uuid TEXT DEFAULT NULL;
    EXCEPTION
      WHEN duplicate_column THEN RAISE NOTICE 'column machine_uuid already exists in report.';
    END;
  END;
$$;
ALTER TABLE report ALTER COLUMN machine_id DROP NOT NULL;
CREATE UNIQUE INDEX IF NOT EXISTS idx_report_daily_uniq ON
    report(report_date, machine_uuid, client_version);


-- TODO (when there are no more report entries with the machine_id column set)
-- ALTER TABLE report DROP COLUMN machine_id;
-- Drop deprecated patch_id column from the report table.
-- ALTER TABLE report DROP COLUMN patch_id;
